<!SGML  "ISO 8879:1986"
-- ArborText's default SGML declaration --

CHARSET
BASESET "ISO 646-1983//CHARSET
 International Reference Version (IRV)//ESC 2/5 4/0"
DESCSET
    0   9   UNUSED
    9   2   9
       11   2   UNUSED
       13   1   13
       14   18  UNUSED
       32   95  32
      127   1   UNUSED
      128   128 "High-order characters"

CAPACITY SGMLREF
    TOTALCAP    200000
    ENTCAP      35000
    ENTCHCAP    35000
    ELEMCAP     35000
    GRPCAP      150000
    EXGRPCAP    35000
    EXNMCAP     35000
    ATTCAP      50000
    ATTCHCAP    35000
    AVGRPCAP    35000
    NOTCAP      35000
    NOTCHCAP    35000
    IDCAP       35000
    IDREFCAP    35000
    MAPCAP      35000
    LKSETCAP    35000
    LKNMCAP     35000

SCOPE    DOCUMENT

SYNTAX
    SHUNCHAR 0 1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17
        18 19 20 21 22 23 24 25 26 27 28 29 30 31 127
BASESET  "ISO 646-1983//CHARSET
          International Reference Version (IRV)//ESC 2/5 4/0"
DESCSET  0  128 0
       128  128 "High-order characters"
FUNCTION RE 13
     RS 10
     SPACE  32
     TAB    SEPCHAR 9
NAMING   LCNMSTRT ""
     UCNMSTRT ""
     LCNMCHAR "-."
     UCNMCHAR "-."
     NAMECASE GENERAL YES
          ENTITY  NO
DELIM    GENERAL SGMLREF
     SHORTREF SGMLREF
NAMES    SGMLREF
QUANTITY SGMLREF
    ATTCNT      100
    ATTSPLEN    960
    BSEQLEN     960
    DTAGLEN     16
    DTEMPLEN    16
    ENTLVL      16
    GRPCNT      100
    GRPGTCNT    96
    GRPLVL      32
    LITLEN      2048
    NAMELEN     64
    NORMSEP     2
    PILEN       1024
    TAGLEN      960
    TAGLVL      24


FEATURES
MINIMIZE DATATAG NO     OMITTAG  YES    RANK     NO     SHORTTAG YES
LINK     SIMPLE  NO     IMPLICIT NO     EXPLICIT NO
OTHER    CONCUR  NO     SUBDOC   YES 99 FORMAL   YES
APPINFO "ARCBASE">
<!DOCTYPE DSSSL-SPECIFICATION [<!-- $Id: archform.sgm,v 1.4 1995/11/22 18:13:53 jjc Exp $ -->
<?IS10744 ArcBase dsssl >
<?ArcBase dsssl >
<!entity % dssslDtd system "dsssl.dtd">
<!notation dsssl PUBLIC
  "ISO/IEC 10179:1996//NOTATION DSSSL Architecture Definition
  Document//EN">
<!attlist #notation dsssl
  ArcDocF NAME #FIXED dsssl-specification
  ArcDTD CDATA "%dssslDtd"
  ArcFormA NAME #FIXED "dsssl"
  ArcQuant CDATA "NAMELEN 64"
  ArcSuprA NAME #FIXED "dssslsupr"
  ArcIgnDA NAME #FIXED "dssslIgnD"
>
<!-- DSSSL Architectural Forms -->
<!-- FIXME forms for specifying associations at SGML level -->

<!ENTITY % declarations
 "features | baseset-encoding | literal-described-char | add-name-chars
  | add-separator-chars | standard-chars | other-chars
  | combine-char | map-sdata-entity | char-repertoire"
>

<!element dsssl-specification - O
          ((%declarations;)*,
           (style-specification | transformation-specification
            | external-specification)+)>
<!attlist dsssl-specification
          version CDATA #FIXED "ISO/IEC 10179:1995"
>

<!element transformation-specification - O
          ((%declarations;)*, transformation-specification-body*)>
<!attlist transformation-specification
          id ID #IMPLIED
    desc CDATA #IMPLIED
          -- human readable description of specification --
    partial (partial | complete) complete
    -- is the specification complete is or is it just a fragment
       to be used in other specifications? --
          use -- reftype(transformation-specification|external-specification) --
              IDREFS #IMPLIED -- Default: none --
          entities
          -- entities available to be specified as DTD for validation
             of result document --
              ENTITIES #IMPLIED -- Default: none --
>

<!element style-specification - O
          ((%declarations;)*, style-specification-body*)>
<!attlist style-specification
          id ID #IMPLIED
    desc CDATA #IMPLIED
          -- human readable description of specification --
    partial (partial | complete) complete
    -- is the specification complete is or is it just a fragment
       to be used in other specifications? --
          use   -- reftype(style-specification|external-specification) --
             IDREFS #IMPLIED -- Default: none --
>

<!-- Assign a local ID to a specification in another document. -->
<!element external-specification - O EMPTY>
<!attlist external-specification
          id ID #REQUIRED
          document -- document containing spec --
                  ENTITY #REQUIRED
          specid -- id of spec in document --
                  NAME #IMPLIED -- Default: first spec in document --
>

<!-- Declares features used by specification. -->
<!element features - O (#PCDATA)
  -- dlextype(featurename*) -->

<!-- Map character numbers in a base character set to character names;
not needed when system knows a character set, and all characters
in character set have universal code. -->
<!element baseset-encoding - O (#PCDATA)
  -- dlextype((number, charname)*) -->
<!attlist baseset-encoding
          name CDATA #REQUIRED -- public identifier of baseset --
>

<!-- Map a character described in the SGML declaration with a minimum literal
to a character name. -->
<!element literal-described-char - O (#PCDATA)
  -- dlextype(charname) -->
<!attlist literal-described-char
          desc CDATA #REQUIRED -- the literal description --
>

<!-- Declare additional characters allowed in name within DSSSL notation. -->
<!element add-name-chars - O (#PCDATA)
  -- dlextype(charname*) -->

<!-- Declare additional characters allowed as separators within
DSSSL notation. -->
<!element add-separator-chars - O (#PCDATA)
  -- dlextype(charname*) -->

<!-- Define characters associating names with universal codes. -->

<!element standard-chars - O (#PCDATA)
  -- dlextype((charname, number))*) -->

<!-- Define characters with no universal codes. -->

<!element other-chars - O (#PCDATA)
  -- dlextype(charname*) -->

<!-- Map an SDATA entity onto a character. -->

<!element map-sdata-entity - O (#PCDATA)
  -- dlextype(charname) -->
<!attlist map-sdata-entity
         name CDATA #IMPLIED -- Default: mapping uses replacement text only --
         text CDATA #IMPLIED -- Default: mapping uses name only --
>

<!-- Declare character combining. -->

<!element combine-char - O (#PCDATA)
  -- dlextype(charname, charname, charname+) -->

<!-- Declare a character repertoire. -->
<!element char-repertoire - O EMPTY>
<!attlist char-repertoire
          name -- public identifier for repertoire --
               CDATA #REQUIRED
>

<!element style-specification-body - - CDATA
  -- content uses notation of DSSSL style language -->
<!attlist style-specification-body
          content ENTITY #CONREF -- Default: syntactic content --
>

<!element transformation-specification-body - - CDATA
  -- content uses notation of DSSSL transformation language -->
<!attlist transformation-specification-body
          content ENTITY #CONREF -- Default: syntactic content --
>
<!notation SGML PUBLIC "8879:1986//NOTATION Standard Generalized Markup Language//EN" >
<!ENTITY xpointer SYSTEM "xpointer.dsl" NDATA SGML >
]>
<DSSSL-SPECIFICATION><STYLE-SPECIFICATION><STYLE-SPECIFICATION-BODY>
(define (ancestors nl)
  (node-list-map
    (lambda (snl)
      (let loop
        ((cur (parent snl))
         (result (empty-node-list)))
        (if (node-list-empty? cur)
          result
          (loop (parent cur)
                (node-list cur result)))))
    nl))(define (list->string xs)
    (apply string xs))
(define (string->list str)
    (let loop ((chars '())
               (k (- (string-length str) 1)))
      (if (< k 0)
          chars
          (loop (cons (string-ref str k) chars) (- k 1)))))
(define (document-element #!optional (node (current-node)))
  (if (node-list-empty? node)
    (error "Empty node list provided to document-element function")
    (cond
      ((equal? 'element (node-property 'classnm node))
        (node-property 'document-element
          (node-property 'grove-root node)))
      ((equal? 'sgml-document (node-property 'classnm node))
       (node-property 'document-element node default: (empty-node-list)))
      (else
       (error "Node passed to document-element is not element or sgmldoc node")))))
(define (node-list-contains? nl snl)
  (node-list-reduce nl
    (lambda (result i)
      (or result (node-list=? snl i)))
    #f))
(define (node-list-intersection #!rest args)
  (if (null? args)
    (empty-node-list)
    (reduce (cdr args)
      (lambda (nl1 nl2)
        (debug (node-list-reduce nl1
          (lambda (result snl)
            (if (node-list-contains? nl2 snl)
              (node-list result snl)
              result))
          (empty-node-list))))
      (node-list-remove-duplicates (car args)))))
(define (node-list-reduce nl combine init)
  (if (node-list-empty? nl)
    init
    (node-list-reduce
      (node-list-rest nl)
      combine
      (combine init (node-list-first nl)))))
(define (node-list-remove-duplicates nl)
  (node-list-reduce nl
    (lambda (result snl)
      (if (node-list-contains? result snl)
          result
          (node-list result snl)))
    (empty-node-list)))
(define (node-list-property prop nl)
  (node-list-map
    (lambda (snl)
      (node-property prop snl default: (empty-node-list)))
    nl))
(define (sort-in-tree-order nl)
  (debug (node-list-intersection
    (subtree (tree-root nl)) nl)))
(define (reduce list combine init)
  (let loop
    ((result init)
     (list list))
    (if (null? list)
      result
      (loop (combine result (car list)) (cdr list)))))
(define (subtree nl)
  (node-list-map
    (lambda (snl)
      (node-list snl (subtree (children snl))))
      nl))
(define
  (tree-after nl)
    (node-list-map
      (lambda (snl)
        (let ((pa (parent snl)))
          (if (node-list-empty? pa)
            (empty-node-list)
            (node-list
              (subtree (follow snl))
              (tree-after pa)))))
      nl))
(define (tree-before? snl1 snl2)
  (let
    ((sorted (debug (sort-in-tree-order (node-list snl1 snl2)))))
    (and (= (node-list-length sorted) 2)
            (node-list=? (node-list-first sorted) snl1))))
(define (tree-root nl)
  (node-list-property 'tree-root nl))
(define (node-list-filter proc nl)
  (node-list-reduce
    nl
    (lambda
      (result snl)
      (if (proc snl)
        (node-list snl result) result))
        (empty-node-list)))
(define (tree-before nl)
  (node-list-map
    (lambda (snl)
      (node-list-filter
        (lambda (x)
          (tree-before? x snl))
        (subtree (tree-root snl))))
    nl))
(define (is-simple-link? element)
  (let ((formname (attribute-string "xml:link" element)))
    (if formname
      (if (or (string=? formname "simple")
              (string=? formname "SIMPLE")) ; NOTE: for normal SGML processing
              #t
              #f
          )
      #f)))
(define (is-extended-link? element)
  (let ((formname (attribute-string "xml:link" element)))
    (if formname
      (if (or (string=? formname "extended")
              (string=? formname "EXTENDED")) ; NOTE: for normal SGML processing
              #t
              #f
          )
      #f)))
(define (is-locator? element)
  (let ((formname (attribute-string "xml:link" element)))
    (if formname
      (if (or (string=? formname "locator")
              (string=? formname "LOCATOR")) ; NOTE: for normal SGML processing
              #t
              #f
          )
      #f)))
(define (is-link-group? element)
  (if (attribute-string "xml:link" element)
      (if (string=? (attribute-string "xml:link" element)
                    "group")
          #t
          #f
      )
      #f))
(define (is-document-link? element)
  (if (attribute-string "xml:link" element)
      (if (string=? (attribute-string "xml:link" element)
                    "document")
          #t
          #f
      )
      #f))
(define (terms->list xptr)
  (if (equal? "" xptr)
    '()
    (let ((xptrlen (string-length xptr)))
      (let loop
        ((terms '())
         (ndx 0))
        (if (>= ndx xptrlen)
          terms
          (let
            ((next
               (let loop2
                 ((ndx (+ ndx 1)))
                 (if (>= ndx xptrlen)
                   ndx
                   (if (char=? #\. (string-ref xptr ndx))
                     ndx
                     (loop2 (+ ndx 1)))))))
            (loop
              (append terms (list (substring xptr ndx next)))
              (+ next 1))))))))
(define (get-xpointer-part uri)
  (let ((urilen (string-length uri)))
    (let loop ((ndx 0))
      (if (> (+ ndx 1) urilen)
        ""
        (if (or (char=? #\# (string-ref uri ndx))
                (char=? #\| (string-ref uri ndx)))
          ; Return rest of string:
          (if (>= (+ ndx 1) urilen)
             (error "Null XPointer in locator. This is not allowed.")
             (substring uri (+ ndx 1) (string-length uri)))
          (loop (+ ndx 1)))))))
(define (get-uri-part locator)
  (let ((loclen (string-length locator)))
    (let loop ((ndx 0))
      (if (> (+ ndx 1) loclen)
        locator
        (if (or (char=? #\# (string-ref locator ndx))
                (char=? #\| (string-ref locator ndx)))
          ; Return first part of string:
          (substring locator 0 ndx)
          (loop (+ ndx 1)))))))
(define (term-name term)
  (let loop
    ((name "")
     (term term))
    (if (equal? "" term)
      name
      (if (char=? #\( (string-ref term 0))
        name
        (loop (string-append name (substring term 0 1))
              (substring term 1 (string-length term)))))))
(define (get-arg-string term)
  (if (equal? "" term)
    ""
    (let loop
      ((term term)
       (argstr ""))
      (if (equal? "" term)
         argstr
         (if (char=? #\( (string-ref term 0))
           (let loop2
             ((term (substring term 1 (string-length term)))
              (argstr argstr))
             (if (equal? "" term)
               (substring argstr 0 (- (string-length argstr) 1))
               (loop2 (substring term 1 (string-length term))
                      (string-append argstr (substring term 0 1)))))
           (loop (substring term 1 (string-length term))
                 argstr))))))


(define (term-args term)
  (if (equal? "" term)
    '()
    (let ((argstring (get-arg-string term)))
      (let ((arglen (string-length argstring)))
        (let loop
          ((args '())
           (ndx 0))
          (if (>= ndx arglen)
            args
            (let
              ((next
                 (let loop2
                   ((ndx (+ ndx 1)))
                   (if (>= ndx arglen)
                     ndx
                     (if (char=? #\, (string-ref argstring ndx))
                       ndx
                       (loop2 (+ ndx 1)))))))
              (loop
                (append args (list (substring argstring ndx next)))
                (+ next 1)))))))))
(define (resolve-URI uri) ;(debug (string-append "Resolving URI '" uri "'")))
  (let ((foo '())
        (sysid
          (if (> (string-length uri) 5)
            (if (string=? "http:" (substring uri 0 5))
              (string-append "<url>" uri)
              uri)
            uri)))
    (let ((docroot (sgml-parse sysid)))
      (if (node-list-empty? docroot)
        (error (string-append "Reference to non-document object '" uri
                              "' from XLink locator."))
        (document-element docroot)))))
(define (resolve-XPointer xpointer locsrc)
  (let loop ((terms (terms->list xpointer))
             (result (empty-node-list))
             (locsrc locsrc))
       (if (null? terms)
         result
         (case (term-name (list-ref terms 0))
           (("id")
            (let ((locsrc
                    (if (node-list-empty? locsrc)
                       (document-element (current-node))
                       locsrc))
                  (result (id (list-ref terms 0) locsrc)))
              (loop (list-tail terms 1)
                    result
                    result)))
           (("root")
             (let ((result (root locsrc)))
               (loop (list-tail terms 1)
                     result
                     result)))
           (("origin")
              (let ((result (origin)))
                (loop (list-tail terms 1)
                      result
                      result)))
           (("html")
              (let ((result (html (list-ref terms 0) locsrc)))
                (loop (list-tail terms 1)
                      result
                      result)))
           (("ancestor")
              (let ((locsrc
                      (if (node-list-empty? locsrc)
                         (document-element (current-node))
                         locsrc))
                    (result (ancestor (list-ref terms 0) locsrc)))
                (loop (list-tail terms 1)
                      result
                      result)))
           (("child")
              (let ((locsrc
                      (if (node-list-empty? locsrc)
                         (document-element (current-node))
                         locsrc))
                    (result (child (list-ref terms 0) locsrc)))
                (loop (list-tail terms 1)
                      result
                      result)))
           (("descendant")
              (let ((locsrc
                      (if (node-list-empty? locsrc)
                         (document-element (current-node))
                         locsrc))
                    (result (descendant (list-ref terms 0) locsrc)))
                (loop (list-tail terms 1)
                      result
                      result)))
           (("following")
              (let ((locsrc
                      (if (node-list-empty? locsrc)
                         (document-element (current-node))
                         locsrc))
                    (result (following (list-ref terms 0) locsrc)))
                (loop (list-tail terms 1)
                      result
                      result)))
           (("fsibling")
              (let ((locsrc
                      (if (node-list-empty? locsrc)
                         (document-element (current-node))
                         locsrc))
                    (result (fsibling (list-ref terms 0) locsrc)))
                (loop (list-tail terms 1)
                      result
                      result)))
           (("psibling")
              (let ((locsrc
                      (if (node-list-empty? locsrc)
                         (document-element (current-node))
                         locsrc))
                    (result (psibling (list-ref terms 0) locsrc)))
                (loop (list-tail terms 1)
                      result
                      result)))
           ; NOTE: Bug in base functions that implement tree-before function
           ;(("preceding")
           ;   (let ((locsrc
           ;           (if (node-list-empty? locsrc)
           ;              (document-element (current-node))
           ;              locsrc))
           ;         (result (preceding (list-ref terms 0) locsrc)))
           ;     (loop (list-tail terms 1)
           ;           result
           ;           result)))
           (else
              (error
                (string-append "Unimplemented location term '"
                                (term-name (list-ref terms 0)) "'.")))))))

(define (id term locsrc)
  (element-with-id (list-ref (term-args term) 0) locsrc))
(define (root locsrc)
  (if (node-list-empty? locsrc)
    (empty-node-list)
    (document-element locsrc)))
(define (origin)
  (current-node))
(define (html term locsrc)
  (let ((namevalue (list-ref (term-args term) 0)))
    (if (equal? "" namevalue)
      (error "No name value specified for html() location term. A name must be specified.")
      (let
        ((cands (select-elements
                  (descendants locsrc)
                  (list "a" (list "name" namevalue)))))
        (if (node-list-empty? cands)
          (let ((foo (debug (string-append "In html(), no A found for name value '"
                                            namevalue "'"))))
            (empty-node-list))
          (node-list-first cands))))))

;("name" namevalue)

(define (select-by-number num nl)
  (if (node-list-empty? nl)
    (empty-node-list)
    (let
      ((nl
         (if (char=? #\- (string-ref num 0))
           (node-list-reverse nl)
           nl))
       (num (abs (string->number num))))
       (if (> num (node-list-length nl))
         (empty-node-list)       ;# Number out of range
         (node-list-ref nl (- num 1))))))

; NOTE: Does not yet do attribute-based selection.
(define (resolve-relative-term termname args locsrc)
  (if (null? args)
    (error (string-append
             "XPointer Error: No arguments specified for "
             termname
             " location term. You must specify at least an instance specifier."))
    (if (node-list-empty? locsrc)
      (error (string-append
               "XPointer Error: empty location source for "
               termname
               " location term."))
      (let
        ((instance (list-ref args 0))
         (node-type
           (if (>= 1 (length args))
             "#element"
             (list-ref args 1))) ;2nd argument is node type
         (attspecs
           (if (>= 2 (length args))
             '()
             (list-tail args 2))))
           ;-----------------------------
           ; Now get candidate node list
           ; then apply remaining terms to
           ; select from that list.
           ;-----------------------------
         (let
           ((cands
             (case node-type
               (("#element")
                 (select-by-class locsrc 'element))
               (("#pi")
                 (select-by-class locsrc 'pi))
               (("#comment")    ; NOTE: Comment nodes not in Jade grove plan
                 (select-by-class children 'comment))
               (("#text")       ; NOTE: This implementation of #text is not correct
                 (data locsrc))
               (("#cdata")      ; NOTE: Not entirely sure how to do #cdata
                 (error "Warning: Jade does not include CDATA marked sections in its grove plan. Cannot resolve #cdata node types."))
                 ;(select-by-class locsrc 'marked-section))
               (("#all")
                 (if (null? attspecs)
                   locsrc
                   (select-by-class locsrc 'element)))
               (else ; Must be a GI
                 (select-elements locsrc (list node-type))))))
           (if (string=? "all" instance)
               cands
               (select-by-number instance cands)))))))
(define (ancestor term locsrc)
  (let ((foo (debug (string-append "Resolving '" term "'")))
        (args (term-args term)))
    (resolve-relative-term "ancestor"
      args
      (node-list-reverse (ancestors locsrc)))))
(define (child term locsrc)
  (let (;(foo (debug (string-append "Resolving '" term "'")))
        (args (term-args term)))
    (resolve-relative-term "child" args (children locsrc))))
(define (descendant term locsrc)
  (let ((foo (debug (string-append "Resolving '" term "'")))
        (args (term-args term)))
    (resolve-relative-term "descendant"
      args
      (descendants locsrc))))
(define (following term locsrc)
  (let ((foo (debug (string-append "Resolving '" term "'")))
        (args (term-args term)))
    (resolve-relative-term "following"
      args
      (let ((nodes (tree-after locsrc)))
        (let ((foo (debug (string-append "node-list-len=" (format-number (node-list-length nodes) "1")))))
        (cond
          ((node-list-empty? nodes)
           (error "Empty node list produced by tree-after function"))
          ((node-list? nodes)
           nodes)
          (else
           nodes))))
)))
(define (preceding term locsrc)
  (let ((foo (debug (string-append "Resolving '" term "'")))
        (args (term-args term)))
    (resolve-relative-term "preceding"
      args
      (let ((nodes (tree-before locsrc)))
        (let ((foo (debug (string-append "node-list-len=" (format-number (node-list-length nodes) "1")))))
        (cond
          ((debug (node-list-empty? nodes))
           (error "Empty node list produced by tree-before function"))
          ((debug (node-list? nodes))
           (reverse nodes))
          (else
           nodes))))
)))
(define (fsibling term locsrc)
  (let ((foo (debug (string-append "Resolving '" term "'")))
        (args (term-args term)))
    (resolve-relative-term "fsibling"
      args
      (let ((nodes (follow locsrc)))
        (cond
          ((node-list-empty? nodes)
           (error "Empty node list produced by follow function"))
          (else
           nodes))))))
(define (psibling term locsrc)
  (let ((foo (debug (string-append "Resolving '" term "'")))
        (args (term-args term)))
    (resolve-relative-term "psibling"
      args
      (let ((nodes (preced locsrc)))
        (cond
          ((node-list-empty? nodes)
           (error "Empty node list produced by preced function"))
          (else
           (node-list-reverse nodes)))))))</STYLE-SPECIFICATION-BODY></STYLE-SPECIFICATION></DSSSL-SPECIFICATION>