<!SGML  "ISO 8879:1986"
-- ArborText's default SGML declaration --

CHARSET
BASESET "ISO 646-1983//CHARSET
 International Reference Version (IRV)//ESC 2/5 4/0"
DESCSET
    0   9   UNUSED
    9   2   9
       11   2   UNUSED
       13   1   13
       14   18  UNUSED
       32   95  32
      127   1   UNUSED
      128   128 "High-order characters"

CAPACITY SGMLREF
    TOTALCAP    200000
    ENTCAP      35000
    ENTCHCAP    35000
    ELEMCAP     35000
    GRPCAP      150000
    EXGRPCAP    35000
    EXNMCAP     35000
    ATTCAP      50000
    ATTCHCAP    35000
    AVGRPCAP    35000
    NOTCAP      35000
    NOTCHCAP    35000
    IDCAP       35000
    IDREFCAP    35000
    MAPCAP      35000
    LKSETCAP    35000
    LKNMCAP     35000

SCOPE    DOCUMENT

SYNTAX
    SHUNCHAR 0 1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17
        18 19 20 21 22 23 24 25 26 27 28 29 30 31 127
BASESET  "ISO 646-1983//CHARSET
          International Reference Version (IRV)//ESC 2/5 4/0"
DESCSET  0  128 0
       128  128 "High-order characters"
FUNCTION RE 13
     RS 10
     SPACE  32
     TAB    SEPCHAR 9
NAMING   LCNMSTRT ""
     UCNMSTRT ""
     LCNMCHAR "-."
     UCNMCHAR "-."
     NAMECASE GENERAL YES
          ENTITY  NO
DELIM    GENERAL SGMLREF
     SHORTREF SGMLREF
NAMES    SGMLREF
QUANTITY SGMLREF
    ATTCNT      100
    ATTSPLEN    960
    BSEQLEN     960
    DTAGLEN     16
    DTEMPLEN    16
    ENTLVL      16
    GRPCNT      100
    GRPGTCNT    96
    GRPLVL      32
    LITLEN      2048
    NAMELEN     64
    NORMSEP     2
    PILEN       1024
    TAGLEN      960
    TAGLVL      24


FEATURES
MINIMIZE DATATAG NO     OMITTAG  YES    RANK     NO     SHORTTAG YES
LINK     SIMPLE  NO     IMPLICIT NO     EXPLICIT NO
OTHER    CONCUR  NO     SUBDOC   YES 99 FORMAL   YES
APPINFO "ARCBASE">
<!DOCTYPE DSSSL-SPECIFICATION [<!-- $Id: archform.sgm,v 1.4 1995/11/22 18:13:53 jjc Exp $ -->
<?IS10744 ArcBase dsssl >
<?ArcBase dsssl >
<!entity % dssslDtd system "dsssl.dtd">
<!notation dsssl PUBLIC
  "ISO/IEC 10179:1996//NOTATION DSSSL Architecture Definition
  Document//EN">
<!attlist #notation dsssl
  ArcDocF NAME #FIXED dsssl-specification
  ArcDTD CDATA "%dssslDtd"
  ArcFormA NAME #FIXED "dsssl"
  ArcQuant CDATA "NAMELEN 64"
  ArcSuprA NAME #FIXED "dssslsupr"
  ArcIgnDA NAME #FIXED "dssslIgnD"
>
<!-- DSSSL Architectural Forms -->
<!-- FIXME forms for specifying associations at SGML level -->

<!ENTITY % declarations
 "features | baseset-encoding | literal-described-char | add-name-chars
  | add-separator-chars | standard-chars | other-chars
  | combine-char | map-sdata-entity | char-repertoire"
>

<!element dsssl-specification - O
          ((%declarations;)*,
           (style-specification | transformation-specification
            | external-specification)+)>
<!attlist dsssl-specification
          version CDATA #FIXED "ISO/IEC 10179:1995"
>

<!element transformation-specification - O
          ((%declarations;)*, transformation-specification-body*)>
<!attlist transformation-specification
          id ID #IMPLIED
    desc CDATA #IMPLIED
          -- human readable description of specification --
    partial (partial | complete) complete
    -- is the specification complete is or is it just a fragment
       to be used in other specifications? --
          use -- reftype(transformation-specification|external-specification) --
              IDREFS #IMPLIED -- Default: none --
          entities
          -- entities available to be specified as DTD for validation
             of result document --
              ENTITIES #IMPLIED -- Default: none --
>

<!element style-specification - O
          ((%declarations;)*, style-specification-body*)>
<!attlist style-specification
          id ID #IMPLIED
    desc CDATA #IMPLIED
          -- human readable description of specification --
    partial (partial | complete) complete
    -- is the specification complete is or is it just a fragment
       to be used in other specifications? --
          use   -- reftype(style-specification|external-specification) --
             IDREFS #IMPLIED -- Default: none --
>

<!-- Assign a local ID to a specification in another document. -->
<!element external-specification - O EMPTY>
<!attlist external-specification
          id ID #REQUIRED
          document -- document containing spec --
                  ENTITY #REQUIRED
          specid -- id of spec in document --
                  NAME #IMPLIED -- Default: first spec in document --
>

<!-- Declares features used by specification. -->
<!element features - O (#PCDATA)
  -- dlextype(featurename*) -->

<!-- Map character numbers in a base character set to character names;
not needed when system knows a character set, and all characters
in character set have universal code. -->
<!element baseset-encoding - O (#PCDATA)
  -- dlextype((number, charname)*) -->
<!attlist baseset-encoding
          name CDATA #REQUIRED -- public identifier of baseset --
>

<!-- Map a character described in the SGML declaration with a minimum literal
to a character name. -->
<!element literal-described-char - O (#PCDATA)
  -- dlextype(charname) -->
<!attlist literal-described-char
          desc CDATA #REQUIRED -- the literal description --
>

<!-- Declare additional characters allowed in name within DSSSL notation. -->
<!element add-name-chars - O (#PCDATA)
  -- dlextype(charname*) -->

<!-- Declare additional characters allowed as separators within
DSSSL notation. -->
<!element add-separator-chars - O (#PCDATA)
  -- dlextype(charname*) -->

<!-- Define characters associating names with universal codes. -->

<!element standard-chars - O (#PCDATA)
  -- dlextype((charname, number))*) -->

<!-- Define characters with no universal codes. -->

<!element other-chars - O (#PCDATA)
  -- dlextype(charname*) -->

<!-- Map an SDATA entity onto a character. -->

<!element map-sdata-entity - O (#PCDATA)
  -- dlextype(charname) -->
<!attlist map-sdata-entity
         name CDATA #IMPLIED -- Default: mapping uses replacement text only --
         text CDATA #IMPLIED -- Default: mapping uses name only --
>

<!-- Declare character combining. -->

<!element combine-char - O (#PCDATA)
  -- dlextype(charname, charname, charname+) -->

<!-- Declare a character repertoire. -->
<!element char-repertoire - O EMPTY>
<!attlist char-repertoire
          name -- public identifier for repertoire --
               CDATA #REQUIRED
>

<!element style-specification-body - - CDATA
  -- content uses notation of DSSSL style language -->
<!attlist style-specification-body
          content ENTITY #CONREF -- Default: syntactic content --
>

<!element transformation-specification-body - - CDATA
  -- content uses notation of DSSSL transformation language -->
<!attlist transformation-specification-body
          content ENTITY #CONREF -- Default: syntactic content --
>
<!notation SGML PUBLIC "8879:1986//NOTATION Standard Generalized Markup Language//EN" >
<!ENTITY xpointer SYSTEM "xpointer.dsl" NDATA SGML >
]>
<DSSSL-SPECIFICATION>
<STYLE-SPECIFICATION use="xpointer"><STYLE-SPECIFICATION-BODY>
(declare-flow-object-class element
  "UNREGISTERED::James Clark//Flow Object Class::element")
(declare-flow-object-class element
  "UNREGISTERED::James Clark//Flow Object Class::element")
(declare-flow-object-class empty-element
  "UNREGISTERED::James Clark//Flow Object Class::empty-element")
(declare-flow-object-class document-type
  "UNREGISTERED::James Clark//Flow Object Class::document-type")
(declare-flow-object-class processing-instruction
  "UNREGISTERED::James Clark//Flow Object Class::processing-instruction")
(declare-flow-object-class entity
  "UNREGISTERED::James Clark//Flow Object Class::entity")
(declare-flow-object-class entity-ref
  "UNREGISTERED::James Clark//Flow Object Class::entity-ref")
(declare-flow-object-class formatting-instruction
  "UNREGISTERED::James Clark//Flow Object Class::formatting-instruction")
(define debug
  (external-procedure "UNREGISTERED::James Clark//Procedure::debug"))
(define (copy-attributes #!optional (nd (current-node)))
  (let loop ((atts (named-node-list-names (attributes nd))))
    (if (null? atts)
        '()
        (let* ((name (car atts))
               (value (attribute-string name nd)))
          (if value
              (cons (list name value)
                    (loop (cdr atts)))
              (loop (cdr atts)))))))
; NOTE: Need to add name remapping--WEK
(define (process-simple-link node)
  (make element gi: "p"
    (sosofo-append
      (make element gi: "b"
         (literal (string-append "Processing simple link element (gi='" (gi node) "'):"))))
      (make element gi: "ul"
        (let ((href (attribute-string "href" node))
             (title (attribute-string "title" node))
             (role (attribute-string "role" node))
             (content-role (attribute-string "content-role" node))
             (show (attribute-string "show" node))
             (actuate (attribute-string "actuate" node)))
           (sosofo-append
             (make element gi: "li"
               (literal (string-append "HREF='" href "'")))
             (if role
               (make element gi: "li"
                 (literal (string-append "role='" role "'")))
               (empty-sosofo))
             (if content-role
               (make element gi: "li"
                 (literal (string-append "content-role='" content-role "'")))
               (empty-sosofo))
             (if show
               (make element gi: "li"
                 (literal (string-append "show='" show "'")))
               (empty-sosofo))
             (if actuate
               (make element gi: "li"
                 (literal (string-append "actuate='" actuate "'")))
               (empty-sosofo))
     (sosofo-append
               (let ((uri  (get-uri-part href))
                     (xptr (get-xpointer-part href)))
                 (let ((locsrc
                         (if (equal? "" uri)
                           (document-element node)
                           (resolve-URI uri))))
                   (if (node-list-empty? locsrc)
                      (error (string-append "In process-simple-link, locsrc is empty "
                                             "node list following locsrc resolution. "
                                             "This should not happen."))
                     (sosofo-append
                       (make element gi: "li"
                         (literal "URI='" uri "'"))
                       (make element gi: "li"
                         (literal "XPTR='" xptr "'"))
                       (let ((xptrtarg
                               (resolve-XPointer
                                 xptr
                                 locsrc)))
                       (make element gi: "li"
                           (if (not (equal? "" xptr))
                             (if (node-list-empty? xptrtarg)
                               (literal "Unable to resolve XPointer.")
                               (sosofo-append
                                 (literal "XPointer resolved to a resource. ")
                                 (literal "Node types are '"
                                   (let loop
                                     ((nl xptrtarg)
                                      (str ""))
                                     (if (node-list-empty? nl)
                                        str
                                        (loop
                                          (node-list-rest nl)
                                          (string-append
                                            str
                                            (symbol->string (node-property 'classnm (node-list-first nl)))
                                            (if (equal? 'element (node-property 'classnm (node-list-first nl)))
                                              (string-append
                                                  "(gi='"
                                                  (gi (node-list-first nl))
                                                  "'), ")
                                               ", ")))))
                                   ". ")
                                 (literal
                                   (string-append "Data ='"
                                     (let ((buf (data xptrtarg)))
                                       (if (> (string-length buf) 40)
                                         (string-append (substring buf 0 40) "...")
                                         buf))
                                     "'."))

))
                             (sosofo-append
                               (literal "No Xpointer, URI resolved to a resource.  ")
                                 (literal "Node type is '"
                                    (symbol->string (node-property 'classnm locsrc))
                                    "'. ")
                                 (if (equal? 'element (node-property 'classnm locsrc))
                                   (literal "GI is '"
                                      (gi locsrc)
                                      "'. ")
                                   (empty-sosofo))
                                 (literal
                                   (string-append "Data ='"
                                     (let ((buf (data locsrc)))
                                       (if (> (string-length buf) 40)
                                         (string-append (substring buf 0 40) "...")
                                         buf))
                                     "'."))))
))))))))))))


; NOTE: Need to add name remapping--WEK
(define (process-extended-link node)
  (make element gi: "p"
    (sosofo-append
      (make element gi: "b"
         (literal (string-append "Processing extended link element (gi='" (gi node) "'):"))))
      (make element gi: "ul"
        (let ((title (attribute-string "title" node))
             (role (attribute-string "role" node))
             (content-role (attribute-string "content-role" node)))
           (sosofo-append
             (if role
               (make element gi: "li"
                 (literal (string-append "role='" role "'")))
               (empty-sosofo))
             (if content-role
               (make element gi: "li"
                 (literal (string-append "content-role='" content-role "'")))
               (empty-sosofo)))))
       ;(with-mode #f (process-children))
))



(define (process-locator node)
  (make element gi: "p"
    (sosofo-append
      (make element gi: "b"
         (literal (string-append "Processing locator element (gi='" (gi node) "'):"))))
      (make element gi: "ul"
        (let ((href (attribute-string "href" node))
             (title (attribute-string "title" node))
             (role (attribute-string "role" node))
             (content-role (attribute-string "content-role" node))
             (show (attribute-string "show" node))
             (actuate (attribute-string "actuate" node)))
           (sosofo-append
             (make element gi: "li"
               (literal (string-append "HREF='" href "'")))
             (if role
               (make element gi: "li"
                 (literal (string-append "role='" role "'")))
               (empty-sosofo))
             (if content-role
               (make element gi: "li"
                 (literal (string-append "content-role='" content-role "'")))
               (empty-sosofo))
             (if show
               (make element gi: "li"
                 (literal (string-append "show='" show "'")))
               (empty-sosofo))
             (if actuate
               (make element gi: "li"
                 (literal (string-append "actuate='" actuate "'")))
               (empty-sosofo))
             (sosofo-append
               (let ((uri  (get-uri-part href))
                     (xptr (get-xpointer-part href)))
                 (let ((locsrc (if (equal? "" uri)
                                node ; NOTE: This should really be principal tree root
                                (resolve-URI uri))))
                   (sosofo-append
                     (make element gi: "li"
                       (literal "URI='" uri "'"))
                     (make element gi: "li"
                       (literal "XPTR='" xptr "'"))
                     (let ((xptrtarg
                             (resolve-XPointer
                               xptr
                               locsrc)))
                       (make element gi: "li"
                           (if (node-list-empty? xptrtarg)
                               (literal "Unable to resolve XPointer.")
                               (sosofo-append
                                 (literal "XPointer resolved to a resource. ")
                                 (literal "Node type is '"
                                    (symbol->string (node-property 'classnm xptrtarg))
                                    "'. ")
                                 (literal
                                   (string-append "Data ='"
                                     (let ((buf (data xptrtarg)))
                                       (if (> (string-length buf) 40)
                                         (string-append (substring buf 0 40) "...")
                                         buf))
                                     "'."))

)))))))))))))


(default
  (let ((foo '())) ;Debugging placeholder, use (gi (current-node))
  (cond
    ((is-simple-link? (current-node))
      (process-simple-link (current-node)))
    ((is-extended-link? (current-node))
      (process-extended-link (current-node))
      )
    ((is-locator? (current-node))
      (process-locator (current-node)))
    ((is-link-group? (current-node))
      (error "Group link not yet implemented"))
    ((is-document-link? (current-node))
      (error "Simple link not yet implemented"))
    (else
      (with-mode normal
        (process-node-list (current-node)))))))


(mode normal
  (element XLinkTest
    (sosofo-append
      (make document-type name: "html" public-id: "-//IETF//DTD HTML//EN")
      (make element gi: "html"
        (with-mode #f
          (process-children)))))

  (element p
    (with-mode #f
      (process-children)))

  (default
    (make element gi: (gi (current-node))
                  attributes: (copy-attributes)
      (with-mode #f
         (process-children))))
)</STYLE-SPECIFICATION-BODY></STYLE-SPECIFICATION>
<EXTERNAL-SPECIFICATION id="xpointer" document="xpointer"></DSSSL-SPECIFICATION>